package QuectelAT

import (
	"bufio"
	"github.com/tarm/serial"
)

type Quectel struct {
	serial    *serial.Port
	ioScanner *bufio.Scanner
}

func (q *Quectel) Open() (err error) {
	q.serial, err = serial.OpenPort(&serial.Config{
		Name: "/dev/ttyUSB2", Baud: 115200,
	})
	if err != nil {
		return
	}
	q.ioScanner = bufio.NewScanner(q.serial)
	err = q.SetEcho(false)
	if err != nil {
		return
	}
	return

}

func (q *Quectel) SendCmd(cmd string) (err error) {
	_, err = q.serial.Write([]byte(cmd + "\r\n"))
	return
}
